Index: /branches/OaaS/HeuristicLab 3.3 Hive.Slave.sln
===================================================================
--- /branches/OaaS/HeuristicLab 3.3 Hive.Slave.sln	(revision 9165)
+++ /branches/OaaS/HeuristicLab 3.3 Hive.Slave.sln	(revision 9166)
@@ -95,5 +95,4 @@
 		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|x86.Build.0 = Release|x86
 		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Debug|Any CPU.ActiveCfg = Debug
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Debug|Any CPU.Build.0 = Debug
 		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Debug|x64.ActiveCfg = Debug
 		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Debug|x64.Build.0 = Debug
@@ -119,5 +118,4 @@
 		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|x86.Build.0 = Release|x86
 		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Debug|Any CPU.ActiveCfg = Debug
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Debug|Any CPU.Build.0 = Debug
 		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Debug|x64.ActiveCfg = Debug
 		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Debug|x64.Build.0 = Debug
Index: /branches/OaaS/HeuristicLab 3.3 Services.sln
===================================================================
--- /branches/OaaS/HeuristicLab 3.3 Services.sln	(revision 9165)
+++ /branches/OaaS/HeuristicLab 3.3 Services.sln	(revision 9166)
@@ -39,5 +39,5 @@
 		Release.AspNetCompiler.FixedNames = "false"
 		Release.AspNetCompiler.Debug = "False"
-		VWDPort = "48545"
+		VWDPort = "25129"
 		VWDVirtualPath = "/Hive-3.3"
 		DefaultWebSiteLanguage = "Visual C#"
@@ -191,5 +191,4 @@
 		{F685556B-F6EB-4143-8E7E-662D00FDD299}.Release|x86.Build.0 = Release|x86
 		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Debug|Any CPU.ActiveCfg = Debug
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Debug|Any CPU.Build.0 = Debug
 		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Debug|Mixed Platforms.ActiveCfg = Debug
 		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Debug|Mixed Platforms.Build.0 = Debug
@@ -335,4 +334,5 @@
 		{E0095F29-604B-4EE8-9EE8-8187DA3B24F1}.Release|x86.ActiveCfg = Release|Any CPU
 		{D6DD768C-707C-415A-B9F8-C1F7668F8560}.Debug|Any CPU.ActiveCfg = Debug|x86
+		{D6DD768C-707C-415A-B9F8-C1F7668F8560}.Debug|Any CPU.Build.0 = Debug|x86
 		{D6DD768C-707C-415A-B9F8-C1F7668F8560}.Debug|Mixed Platforms.ActiveCfg = Debug|x86
 		{D6DD768C-707C-415A-B9F8-C1F7668F8560}.Debug|Mixed Platforms.Build.0 = Debug|x86
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs	(revision 9166)
@@ -6,4 +6,6 @@
 using Microsoft.WindowsAzure;
 using Microsoft.WindowsAzure.StorageClient;
+using Microsoft.WindowsAzure.ServiceRuntime;
+using System.Diagnostics;
 
 namespace HeuristicLab.Services.Optimization.ControllerService.Azure {
@@ -98,5 +100,11 @@
       get {
         if (storageAccount == null) {
-          storageAccount = CloudStorageAccount.Parse(CloudConfigurationManager.GetSetting(AzureConstants.CLOUD_SETTINGS_KEY));
+          try {
+            storageAccount = CloudStorageAccount.Parse(CloudConfigurationManager.GetSetting(AzureConstants.CLOUD_SETTINGS_KEY));
+          }
+          catch (Exception ex) {
+            Trace.WriteLine(ex.Message);
+            storageAccount = CloudStorageAccount.Parse("DefaultEndpointsProtocol=https;AccountName=optimizationstorage1;AccountKey=n7Leom8ZFWkof/VQ2a4aRSvwOlX+Gwr3uojQF9CFJw1osmGCV0WwaNC8s7nkZ+qteLduAgW2l75WFpbXrkvG4Q==");
+          }
         }
         return storageAccount; 
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/General/Configuration.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/General/Configuration.cs	(revision 9166)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/General/Configuration.cs	(revision 9166)
@@ -0,0 +1,22 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using Microsoft.WindowsAzure.ServiceRuntime;
+using System.Configuration;
+
+namespace HeuristicLab.Services.Optimization.ControllerService.General {
+  public static class Configuration {
+    private static string GetSetting(string setting) {
+      if (RoleEnvironment.IsAvailable) {
+        return RoleEnvironment.GetConfigurationSettingValue(setting);
+      }
+      else {
+        return ConfigurationManager.AppSettings[setting];
+      }
+    }
+
+    public static string HiveEndpointName { get { return GetSetting("HiveEndpointName"); } }
+    public static string ControllerEndpointName { get { return GetSetting("ControllerEndpointName"); } }
+  }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HLMapper.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HLMapper.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HLMapper.cs	(revision 9166)
@@ -11,5 +11,5 @@
 namespace HeuristicLab.Services.Optimization.ControllerService {
   public interface IScenarioMapper {
-    void MapScenario(OptimizationScenario scenario, IAlgorithm algorithm);
+    void MapScenario(OptimizationScenario scenario, out IAlgorithm algorithm);
   }
 
@@ -18,4 +18,9 @@
       var dv = parameter.Value as DecimalValue;
       return new DoubleValue(dv.Value);      
+    }
+
+    public static T Create<T>(Parameter typeParameter) {
+      var type = Type.GetType((typeParameter.Value as TypeValue).Value);      
+      return (T)Activator.CreateInstance(type, null);
     }
 
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveMapper.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveMapper.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveMapper.cs	(revision 9166)
@@ -7,5 +7,5 @@
 namespace HeuristicLab.Services.Optimization.ControllerService.Model {
   public static class HiveMapper {    
-    public static double FindDoubleValue(this InputParameters ip, string what) {     
+    public static double FindDoubleValue(this ProblemParameters ip, string what) {     
       foreach (var param in ip.Items) {
         if (param.Value.Name == what) {
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs	(revision 9166)
@@ -20,4 +20,5 @@
 using HeuristicLab.Services.Optimization.ControllerService.Azure;
 using System.Data;
+using HeuristicLab.Services.Optimization.ControllerService.General;
 
 namespace HeuristicLab.Services.Optimization.ControllerService {
@@ -43,5 +44,5 @@
     private static object lockable;
     private Dictionary<string, IScenarioMapper> mappers = new Dictionary<string, IScenarioMapper>();
-    private IDataAccessLayer dal = new AzureDataAccessLayer();
+    private IDataAccessLayer dal = DataAccessLayerProvider.GetLayer();
 
     public static readonly string SCENARIO_TABLE = "Scenario";
@@ -51,15 +52,23 @@
     }
 
-    public void DispatchScenario(Model.User user, Model.OptimizationScenario scenario) {
-      Experiment experiment = new Experiment();
-      var problem = new TravelingSalesmanProblem();
-      var algo = new GeneticAlgorithm();
-      algo.Problem = problem;      
+    public void DispatchScenario(Model.User user, Model.OptimizationScenario scenario, JobExecutionDetails details) {
+      // Experiment experiment = new Experiment();
+      // var problem = new TravelingSalesmanProblem();
+      // var algo = new GeneticAlgorithm();
+      // algo.Problem = problem;      
       
       IScenarioMapper mapper = GetMapper(scenario);
-      mapper.MapScenario(scenario, algo);  
-
-      //experiment.Optimizers.Add(algo);
-      SendExperimentToHive(user, algo);
+      IAlgorithm algo;
+      mapper.MapScenario(scenario, out algo);
+      if (details.Repititions > 1) {
+        BatchRun br = new BatchRun();
+        //br.Name = details.JobTitle;
+        br.Optimizer = algo;        
+        br.Repetitions = details.Repititions;
+        SendExperimentToHive(user, br, details);
+      }
+      else {       
+        SendExperimentToHive(user, algo, details);
+      }
     }
 
@@ -73,5 +82,5 @@
     }
 
-    private IScenarioMapper CompileMapper(string scenarioMapper) {
+    public static IScenarioMapper CompileMapper(string scenarioMapper) {
        // http://stackoverflow.com/questions/3188882/compile-and-run-dynamic-code-without-generating-exe
       using (var csCodeProvider = new Microsoft.CSharp.CSharpCodeProvider()) {
@@ -105,13 +114,14 @@
 
     private IScenarioMapper GetMapper(Model.OptimizationScenario scenario) {
-      if (!mappers.ContainsKey(scenario.Name)) {
+      var id = scenario.Id;
+      if (!mappers.ContainsKey(id)) {
         lock (lockable) {
-          if (mappers.ContainsKey(scenario.Name))
-            return mappers[scenario.Name];
+          if (mappers.ContainsKey(id))
+            return mappers[id];
           
-          var mapperString = GetMapperFromBlobStore(scenario.Name);
+          var mapperString = GetMapperFromBlobStore(id);
           var mapper = CompileMapper(mapperString);
 
-          mappers[scenario.Name] = mapper;
+          mappers[id] = mapper;
           return mapper;
         } // lock        
@@ -120,19 +130,26 @@
      }  
 
-    private void MapExperiment(Model.OptimizationScenario scenario, IAlgorithm algorithm) {      
+    private void MapExperiment(Model.OptimizationScenario scenario, out IAlgorithm algorithm) {      
       IScenarioMapper mapper = GetMapper(scenario);
-      mapper.MapScenario(scenario, algorithm);     
-    }
-
-    private void SendExperimentToHive(Model.User user, IAlgorithm exp) {
+      mapper.MapScenario(scenario, out algorithm);     
+    }
+
+    private void ConfigureHive(Model.User user) {
+      HiveServiceLocator.Instance.Username = user.Username;
+      HiveServiceLocator.Instance.Password = user.Password;
+      HiveServiceLocator.Instance.EndpointConfigurationName = Configuration.HiveEndpointName;      
+    }
+
+    private void SendExperimentToHive(Model.User user, IOptimizer exp, JobExecutionDetails details) {      
       var job = new RefreshableJob();
       job.IsAllowedPrivileged = true;      
-      job.Job.Name = "Web Scheduled Traveling Salesman Job";
-      job.Job.ResourceNames = "TESTGROUP";
-      job.RefreshAutomatically = false;
+      job.Job.Name = details.JobTitle;
+      job.Job.ResourceNames = details.Group;      
+      job.RefreshAutomatically = false;     
+      if (exp.ExecutionState != ExecutionState.Prepared) {
+        exp.Prepare();
+      }      
       job.HiveTasks.Add(new OptimizerHiveTask(exp));
-      HiveServiceLocator.Instance.Username = user.Username;
-      HiveServiceLocator.Instance.Password = user.Password;
-      HiveServiceLocator.Instance.EndpointConfigurationName = "WSHttpBinding_IHiveService";
+      ConfigureHive(user);
       
       HiveClient.StartJob((ex) => { 
@@ -145,10 +162,8 @@
 
     public IList<Model.Job> GetJobs(User user) {
-      HiveServiceLocator.Instance.Username = user.Username;
-      HiveServiceLocator.Instance.Password = user.Password;
-      HiveServiceLocator.Instance.EndpointConfigurationName = "WSHttpBinding_IHiveService";
+      ConfigureHive(user);
       var jobsLoaded = HiveServiceLocator.Instance.CallHiveService<IEnumerable<HeuristicLab.Clients.Hive.Job>>(s => s.GetJobs());
       IList<Model.Job> jobs = new List<Model.Job>();
-      
+
       foreach (var job in jobsLoaded) {
         jobs.Add(ConvertJob(user, job));
@@ -163,28 +178,8 @@
       if (job.CalculatingCount > 0)
         state = JobState.Calculating;
-      else if (job.JobCount == job.FinishedCount)
+      else if (job.JobCount > 0 && job.JobCount == job.FinishedCount)
         state = JobState.Finished;
       else
         state = JobState.Waiting;
-      /*var jobTasks = HiveServiceLocator.Instance.CallHiveService<IEnumerable<HeuristicLab.Clients.Hive.LightweightTask>>(s => s.GetLightweightJobTasks(job.Id));
-      
-      foreach (var task in jobTasks) {        
-        switch (task.State) {
-          case TaskState.Aborted:
-            state = JobState.Aborted;
-            break;
-          case TaskState.Failed:
-            state = JobState.Failed;
-            break;
-        }
-      }
-      if (!state.HasValue) {
-        if (job.CalculatingCount > 0)
-          state = JobState.Calculating;
-        else if (waitingJobs > 0)
-          state = JobState.Waiting;
-        else
-          state = JobState.Finished;        
-      }*/
       return new Model.Job() { Id = job.Id.ToString(), Name = job.Name, Resource = job.ResourceNames, State = state.Value, DateCreated = job.DateCreated };
     }
@@ -192,7 +187,5 @@
 
     public Model.Job GetJob(User user, string id) {
-      HiveServiceLocator.Instance.Username = user.Username;
-      HiveServiceLocator.Instance.Password = user.Password;
-      HiveServiceLocator.Instance.EndpointConfigurationName = "WSHttpBinding_IHiveService";
+      ConfigureHive(user);
       var guid = Guid.Parse(id);
       return ConvertJob(user, HiveServiceLocator.Instance.CallHiveService<HeuristicLab.Clients.Hive.Job>(s => s.GetJob(guid)));
@@ -201,7 +194,5 @@
 
     public void DeleteJob(User user, string id) {
-      HiveServiceLocator.Instance.Username = user.Username;
-      HiveServiceLocator.Instance.Password = user.Password;
-      HiveServiceLocator.Instance.EndpointConfigurationName = "WSHttpBinding_IHiveService";
+      ConfigureHive(user);
       var guid = Guid.Parse(id);
       HiveServiceLocator.Instance.CallHiveService(s => s.DeleteJob(guid));      
@@ -209,7 +200,5 @@
 
     public IList<Model.Run> GetJobResults(User user, string id) {
-      HiveServiceLocator.Instance.Username = user.Username;
-      HiveServiceLocator.Instance.Password = user.Password;
-      HiveServiceLocator.Instance.EndpointConfigurationName = "WSHttpBinding_IHiveService";
+      ConfigureHive(user);
       var guid = Guid.Parse(id);
       var jobTasks = HiveServiceLocator.Instance.CallHiveService<IEnumerable<HeuristicLab.Clients.Hive.LightweightTask>>(s => s.GetLightweightJobTasks(guid));
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/ScenarioParser.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/ScenarioParser.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/ScenarioParser.cs	(revision 9166)
@@ -9,4 +9,5 @@
 using HeuristicLab.Services.Optimization.ControllerService.Azure;
 using HeuristicLab.Services.Optimization.ControllerService.Interfaces;
+using System.Diagnostics;
 
 namespace HeuristicLab.Services.Optimization.ControllerService {
@@ -15,5 +16,5 @@
     private static object lockable = new object();
 
-    private IDataAccessLayer dal = new AzureDataAccessLayer();
+    private IDataAccessLayer dal = DataAccessLayerProvider.GetLayer();
 
     public IList<Model.OptimizationScenario> Scenarios {
@@ -32,5 +33,5 @@
     public Model.OptimizationScenario GetByName(string name) {
       foreach (var scen in Scenarios) {
-        if (scen.Name == name) {
+        if (scen.Id == name) {
           return scen;
         }
@@ -115,4 +116,72 @@
     } */
 
+    private Model.Problem ParseProblem(XmlReader reader) {
+      var problem = new Model.Problem();
+      while (reader.Read()) {
+        if (reader.NodeType == XmlNodeType.EndElement)
+          break;
+        if (reader.Name == "parameters")
+          problem.Parameters.Items = ParseParameters(reader);
+      }
+      return problem;
+    }
+
+    private void ParseAlgorithms(out IList<Model.Algorithm> algos, XmlReader reader) {
+      algos = new List<Model.Algorithm>();
+      var depth = reader.Depth;
+      do {
+        if (reader.Name == "algorithm" && reader.Depth == depth) {
+          var innerAlg = new Model.Algorithm();
+          algos.Add(innerAlg);
+          
+          innerAlg.Mapper = reader.GetAttribute("mapper");
+          reader.Read();
+          for (;;) {
+            if (reader.Name == "algorithm" && reader.NodeType == XmlNodeType.EndElement)
+              break;
+
+            if (reader.Name == "parameters" && reader.NodeType == XmlNodeType.Element) {
+              innerAlg.Parameters.Items = ParseParameters(reader);
+              continue;
+            }
+            else if (reader.Name == "problem" && reader.NodeType == XmlNodeType.Element) {
+              innerAlg.Problem = ParseProblem(reader);
+              continue;
+            }
+            else if (reader.Name == "algorithm" && reader.NodeType == XmlNodeType.Element) {
+              IList<Model.Algorithm> childAlgos;
+              ParseAlgorithms(out childAlgos, reader);
+              innerAlg.ChildAlgorithms = childAlgos;
+              //TODO: Test with child algorithms
+              continue;
+            }
+            reader.Read();
+          }
+        }
+      } while (reader.Read() && reader.Depth >= depth);
+    }
+
+    private Model.OptimizationScenario ParseScenarioElement(XmlReader reader) {
+      var scenario = new Model.OptimizationScenario();
+      var depth = reader.Depth;
+      while (reader.Depth >= depth) {
+        if (reader.Name == "scenario" && reader.NodeType == XmlNodeType.EndElement)
+          break;
+
+        if (reader.Name == "name") {
+          scenario.Id = reader.ReadElementContentAsString();
+          continue;
+        }
+        else if (reader.Name == "algorithm") {
+          IList<Model.Algorithm> algos;
+          ParseAlgorithms(out algos, reader);
+          scenario.Algorithm = algos;
+          continue;
+        }
+        reader.Read();
+      }
+      return scenario;
+    }
+
     private Model.OptimizationScenario ParseScenario(StringReader str) {
       // Set the validation settings.      
@@ -120,29 +189,12 @@
       var settings = GetSettings();
       settings.ValidationEventHandler += (sender, args) => {
-        Console.WriteLine(args.Message);
+        Trace.WriteLine(args.Message);
         isErrorPresent = true;
       };
-      Model.OptimizationScenario scenario = null;
+      Model.OptimizationScenario scenario = null;      
       using (var reader = XmlReader.Create(str, settings)) {        
-        while (!isErrorPresent && !reader.EOF) {
+        while (!reader.EOF) {
           if (reader.Name == "scenario" && reader.NodeType == XmlNodeType.Element) {
-            scenario = new Model.OptimizationScenario();
-            scenario.ProblemType = reader.GetAttribute("mapper");
-            scenario.ProblemType = reader.GetAttribute("algorithmType");
-            scenario.ProblemType = reader.GetAttribute("problemType");
-          }
-          else if (reader.Name == "name") {
-            scenario.Name = reader.ReadElementContentAsString();
-            continue;
-          }
-          else if (reader.Name == "problemParameters") {
-            IList<Model.Parameter> problemParameters = ParseParameters(reader);
-            foreach (var param in problemParameters)
-              scenario.InputParameters.Items.Add(param);
-          }
-          else if (reader.Name == "algorithmParameters") {
-            IList<Model.Parameter> algoParameters = ParseParameters(reader);
-            foreach (var param in algoParameters)
-              scenario.AlgorithmParameters.Items.Add(param);
+            scenario = ParseScenarioElement(reader);            
           }
           reader.Read();
@@ -185,8 +237,8 @@
       IList<Model.Parameter> parameters = new List<Model.Parameter>();
       while (reader.Read()) {
-        if (reader.Name.EndsWith("Parameters"))
+        if (reader.Name == "parameters" && reader.NodeType == XmlNodeType.EndElement)
           break;
         // parse parameter
-        if (reader.Depth == 2 && reader.Name == "param" && reader.NodeType == XmlNodeType.Element) {
+        if (reader.Name == "param" && reader.NodeType == XmlNodeType.Element) {
           var param = new Model.Parameter();
           var typeAtt = reader.GetAttribute("type");
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj	(revision 9166)
@@ -36,4 +36,10 @@
       <HintPath>..\bin\ALGLIB-3.5.0.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.ALGLIB-3.5.0">
+      <HintPath>..\bin\HeuristicLab.ALGLIB-3.5.0.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Algorithms.Benchmarks-3.3">
+      <HintPath>..\bin\HeuristicLab.Algorithms.Benchmarks-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Algorithms.GeneticAlgorithm-3.3">
       <HintPath>..\bin\HeuristicLab.Algorithms.GeneticAlgorithm-3.3.dll</HintPath>
@@ -92,4 +98,7 @@
       <HintPath>..\bin\HeuristicLab.Operators-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Operators.Views.GraphVisualization-3.3">
+      <HintPath>..\bin\HeuristicLab.Operators.Views.GraphVisualization-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Optimization-3.3">
       <HintPath>..\HeuristicLab.Optimization\3.3\obj\Debug\HeuristicLab.Optimization-3.3.dll</HintPath>
@@ -129,4 +138,7 @@
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\bin\HeuristicLab.Selection-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.SequentialEngine-3.3">
+      <HintPath>..\bin\HeuristicLab.SequentialEngine-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Tracing-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
@@ -153,5 +165,5 @@
   <ItemGroup>
     <Compile Include="Azure\DAL.cs" />
-    <Compile Include="HL\HiveScenarioManagerOld.cs" />
+    <Compile Include="General\Configuration.cs" />
     <Compile Include="HL\HiveMapper.cs" />
     <Compile Include="HL\HiveScenarioManager.cs" />
@@ -161,4 +173,6 @@
     <Compile Include="Interfaces\IScenarioManager.cs" />
     <Compile Include="Interfaces\Model\ControllerModel.cs" />
+    <Compile Include="Mockup\MockupDAL.cs" />
+    <Compile Include="Mockup\MockupScenarioManager.cs" />
     <Compile Include="PlaceholderControllerService.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
@@ -172,4 +186,5 @@
     <None Include="packages.config" />
   </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs	(revision 9166)
@@ -27,4 +27,13 @@
     IBlobDao CreateBlobDao();
   }
+
+  public static class DataAccessLayerProvider {    
+    private static IDataAccessLayer layer = new Azure.AzureDataAccessLayer();
+    //private static IDataAccessLayer layer = new Mockup.MockupDataAccessLayer();
+
+    public static IDataAccessLayer GetLayer() { 
+      return layer; 
+    }
+  }
 }
 
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs	(revision 9166)
@@ -20,5 +20,5 @@
 
     [OperationContract]
-    void ScheduleOptimizationScenario(User user, OptimizationScenario scenario);
+    void ScheduleOptimizationScenario(User user, OptimizationScenario scenario, JobExecutionDetails details);
 
     [OperationContract]
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs	(revision 9166)
@@ -7,5 +7,5 @@
 namespace HeuristicLab.Services.Optimization.ControllerService.Interfaces {
   public interface IScenarioManager {
-    void DispatchScenario(User user, OptimizationScenario scenario);
+    void DispatchScenario(User user, OptimizationScenario scenario, JobExecutionDetails details);
     IList<Job> GetJobs(User user);
     Job GetJob(User user, string id);
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/Model/ControllerModel.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/Model/ControllerModel.cs	(revision 9165)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/Model/ControllerModel.cs	(revision 9166)
@@ -45,4 +45,40 @@
     public string[] RowNames { get; set; }
 
+    public void CopyRow(int index) {
+      var newData = new double[Value.Length + 1][];
+      var copyRow = new double[Value[index].Length];
+      for (var i = 0; i < copyRow.Length; i++) {
+        copyRow[i] = Value[index][i];
+      }
+      for (var i = 0; i < newData.Length; i++) {
+        if (i < index) {
+          newData[i] = Value[i];
+        }
+        else if (i == index) {
+          newData[i] = copyRow;
+        }
+        else if (i > index) {
+          newData[i] = Value[i - 1];
+        }
+      }
+      Value = newData;
+    }
+
+    public void DeleteRow(int index) {
+      if (Value.Length == 1)
+        return;
+
+      var newData = new double[Value.Length - 1][];
+      for (var i = 0; i < Value.Length; i++) {
+        if (i < index) {
+          newData[i] = Value[i];
+        }
+        else if (i > index) {
+          newData[i - 1] = Value[i];
+        }
+      }
+      Value = newData;
+    }
+
     public override bool TrySetFromString(string input) {
       var splitted = input.Split(':');
@@ -61,5 +97,5 @@
         return false;
       // very, very buggy
-      if (i >= Value.Length || j >= Value[0].Length ) {
+      /*if (i >= Value.Length || j >= Value[0].Length ) {
         double[][] valueArr = new double[i >= Value.GetLength(0) ? i : Value.GetLength(0)][];        
         for (int k = 0; k < Value.Length; k++) {
@@ -70,5 +106,5 @@
         }
         Value = valueArr;
-      }
+      }*/
 
       Value[i][j] = value;
@@ -186,5 +222,5 @@
 
   [DataContract]
-  public class InputParameters {
+  public class ProblemParameters {
     private IList<Parameter> items = new List<Parameter>();
 
@@ -226,76 +262,108 @@
 
   [DataContract]
+  public class Problem {
+    public Problem() { Parameters = new ProblemParameters(); }
+
+    [DataMember]
+    public ProblemParameters Parameters { get; set; }
+
+    [DataMember]
+    public string Class { get; set; }
+  }
+
+  [DataContract]
+  public class Algorithm {
+    public Algorithm() { Parameters = new AlgorithmParameters(); }
+
+    [DataMember]
+    public AlgorithmParameters Parameters { get; set; }
+
+    [DataMember]
+    public Problem Problem{ get; set; }
+
+    [DataMember]
+    public IList<Algorithm> ChildAlgorithms { get; set; }
+
+    [DataMember]
+    public string Class { get; set; }
+
+    [DataMember]
+    public string Mapper { get; set; }
+  }
+
+  [DataContract]
   public class OptimizationScenario {
     [DataMember]
+    public string Id { get; set; }
+   
+    [DataMember]
+    public IList<Algorithm> Algorithm { get; set; }
+
+    public Algorithm FirstAlgorithm { get { return Algorithm.FirstOrDefault(); } }  
+  }
+
+  [DataContract]
+  public class Experiment {
+    [DataMember]
+    public IList<OptimizationScenario> Scenarios { get; set; }
+
+    public Experiment() {
+      Scenarios = new List<OptimizationScenario>();
+    }
+  }
+
+  [DataContract]
+  public enum JobState {
+    [EnumMember]
+    Waiting,
+    [EnumMember]
+    Calculating,
+    [EnumMember]
+    Aborted,
+    [EnumMember]
+    Failed,
+    [EnumMember]
+    Finished
+  }
+
+  [DataContract]
+  public class JobExecutionDetails {
+    [DataMember]
+    public int Repititions { get; set; }
+
+    [DataMember]
+    public string JobTitle { get; set; }
+
+    [DataMember]
+    public string Group { get; set; }
+  }
+
+  [DataContract]
+  public class Job {
+    [DataMember]
+    public string Id { get; set; }
+
+    [DataMember]
+    public JobState State { get; set; }
+
+    [DataMember]
     public string Name { get; set; }
 
     [DataMember]
-    public string ProblemType { get; set; }
-
-    [DataMember]
-    public string AlgorithmType { get; set; }
-
-    [DataMember]
-    public string MapperType { get; set; }
-
-    private InputParameters inputParams = new InputParameters();
-
-    [DataMember]
-    public InputParameters InputParameters {
-      get { return inputParams; }
-      set { inputParams = value; }
-    }
-
-
-    private AlgorithmParameters algorithmParameters = new AlgorithmParameters();
-
-    [DataMember]
-    public AlgorithmParameters AlgorithmParameters {
-      get { return algorithmParameters; }
-      set { algorithmParameters = value; }
-    }
-  }
-
-  [DataContract]
-  public enum JobState {
-    [EnumMember]
-    Waiting,
-    [EnumMember]
-    Calculating,
-    [EnumMember]
-    Aborted,
-    [EnumMember]
-    Failed,
-    [EnumMember]
-    Finished
-  }
-
-  [DataContract]
-  public class Job {
+    public string Resource { get; set; }
+
+    [DataMember]
+    public DateTime DateCreated { get; set; }
+  }
+
+  [DataContract]
+  public class Run {
     [DataMember]
     public string Id { get; set; }
 
     [DataMember]
-    public JobState State { get; set; }
-
-    [DataMember]
     public string Name { get; set; }
 
     [DataMember]
-    public string Resource { get; set; }
-
-    [DataMember]
-    public DateTime DateCreated { get; set; }
-  }
-
-  [DataContract]
-  public class Run {
-    [DataMember]
-    public string Id { get; set; }
-
-    [DataMember]
-    public string Name { get; set; }
-
-    [DataMember]
     public IList<Parameter> Results { get; set; }
   }
